import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Random;

import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

public class WhereForDateUTC {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("objectdb:testDate.tmp;drop");

		EntityManager em = emf.createEntityManager();

		SimpleDateFormat formatter = new SimpleDateFormat("yyyy/MM/dd");
		Random randomGenerator = new Random();
		// create objects
		em.getTransaction().begin();
		for (int x = 0; x < 100; x++) {
			int month = randomGenerator.nextInt(12);
			int day = randomGenerator.nextInt(30);

			String date = 2011 + "/" + month + "/" + day;
			try {
				Date d = formatter.parse(date);
				em.persist(new TestObject(d));
			} catch (ParseException e) {
				e.printStackTrace();
			}
		}
		em.getTransaction().commit();
		em.close();

		em = emf.createEntityManager();
		TypedQuery<TestObject> query1 = em.createQuery("SELECT o from TestObject o", TestObject.class);
		List<TestObject> result = query1.getResultList();
		System.out.println("Number of dates: " + result.size());
		em.close();

		em = emf.createEntityManager();
		TypedQuery<TestObject> query2 = em.createQuery("SELECT o from TestObject o where o.date > :someDate", TestObject.class);
		query2.setParameter("someDate", "2011-03-01");
		List<TestObject> result2 = query2.getResultList();
		System.out.println("Number of dates result 2: " + result2.size());
		em.close();

		em = emf.createEntityManager();
		TypedQuery<TestObject> query3 = em.createQuery("SELECT o from TestObject o where date(o.date) > :someDate", TestObject.class);
		query3.setParameter("someDate", "2011-03-01");

		List<TestObject> result3 = query3.getResultList();
		System.out.println("Number of dates result 3: " + result3.size());
		em.close();

		em = emf.createEntityManager();
		TypedQuery<TestObject> query4 = em.createQuery("SELECT o from TestObject o where o.date > :someDate", TestObject.class);
		try {
			query4.setParameter("someDate", formatter.parse("2011/03/01"));
		} catch (ParseException e) {
			e.printStackTrace();
		}

		List<TestObject> result4 = query4.getResultList();
		System.out.println("Number of dates result 4: " + result4.size());
		em.close();

		emf.close();
	}

	@Entity
	private static class TestObject {
		@Id
		@GeneratedValue(strategy = GenerationType.AUTO)
		private long id;
		private Date date;

		public TestObject(Date date) {
			super();
			this.date = date;
		}

		/**
		 * @return the id
		 */
		public long getId() {
			return id;
		}

		/**
		 * @param id
		 *            the id to set
		 */
		public void setId(long id) {
			this.id = id;
		}

		/**
		 * @return the date
		 */
		public Date getDate() {
			return date;
		}

		/**
		 * @param date
		 *            the date to set
		 */
		public void setDate(Date date) {
			this.date = date;
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see java.lang.Object#toString()
		 */
		@Override
		public String toString() {
			StringBuilder builder = new StringBuilder();
			builder.append(id).append(", ");
			if (date != null)
				builder.append(date);
			return builder.toString();
		}
	}

}
